#! /usr/bin/env python
# _*-coding:utf-8-*-
# Modifié par PPPP, GPLv3+
# Script qui gère l'affichage des sources video avec des filtres eventuels
# AntsTracking v0.2.2/mod_affichage v0.2.2

# Pas d'affichage, choix du fond, choix des filtres, affichage des fps, choix des curseurs
arch = 'mac'	# Possibilities : 'debian', 'mac'
# ========= Importation
import cv, time, copy, cv2
if arch == 'mac' :
	import numpy, os, sqlite3
	#from scipy import misc
	tmp_image = './tmp/tmp/tmp'
	tmp_image_ext = '.tif'
	#tmp_db = './tmp/tmp/tmp.tif.db'
	tmp_lock = './tmp/tmp/tmp.tif.lock'
	tmp_letter = './tmp/tmp/tmp.tif.letter'
	tmp_click = './tmp/tmp/tmp.tif.click'

# ========= Fonctions
def init(data, name, movie) :
	if arch == 'debian' :
		cv.NamedWindow (name, cv.CV_WINDOW_AUTOSIZE)		# first, create the necessary windows
	elif arch == 'mac' :
		try :
			os.remove(tmp_db)
		except :
			pass
		#movie.db_init = False 
	#### Modify the call here : needs data AND movie
	cv.SetMouseCallback (name, on_mouse, {'data' : data, 'movie' : movie})	# register the mouse callback
	# ==== Gestion des trackbar
	gestion_track = GestionTrackbar()	# Définition de la classe 'mémoire'
	gestion_track.var = {}
	gestion_track.var['seuil1'] = data['seuil1']	# Initialisation des variables
	gestion_track.var['seuil2'] = data['seuil2']
	gestion_track.var['seuil3'] = data['seuil3']
	gestion_track.var['erosion'] = data['erosion']
	####cv.CreateTrackbar("Seuil Adapatif", name, data['seuil1'], 255, gestion_track.seuil1)	# Création des trackbar
	####cv.CreateTrackbar("Seuil 1", name, data['seuil2'], 255, gestion_track.seuil2)
	####cv.CreateTrackbar("Seuil 2", name, data['seuil3'], 255, gestion_track.seuil3)
	####cv.CreateTrackbar("Erosion", name, 0, 10, gestion_track.erosion)
	return gestion_track
		  
def affichage(fps, tracking_data, tracking_data2, dico_images, gestion_track, communicate, movie, self, draw_points) :
	frame = dico_images['brut']	# Swapping
	size = cv.GetSize(frame)
	diff = dico_images['diff']	# id.
	grey2 = dico_images['grey2']	# id.

	# ==== Handling user key pressing/button
	cc = movie.get_key_pressed()[0]
	if cc != -1 :
		  """if cc == 'r':
			  tracking_data['need_to_init'] = True
		  elif cc == 'c':
			  tracking_data['features'] = []
		  elif cc == 'n':
			  tracking_data['night_mode'] = not tracking_data['night_mode']
		  elif cc == 's' :	# Affichage des points
		  	if retour[1] :
					retour[1] = 0
				else : 
					retour[1] = 1"""
		  # elif -> if
		  if cc == "i" :
		  	movie.change_view()
		  elif cc == "e" : 				# Saving image
		  	tracking_data['save'] = 1
		  elif cc == "b" :
		  	tracking_data['next'] = 1
		  elif cc == "Shift_R" :	# Play/pause
		  	movie.change_play()
		  elif cc == "m" :	# Play faster
		  	movie.change_speed(+1)
		  elif cc == "l" :	# Play slower
		  	movie.change_speed(-1)
		  elif cc == 'p' :
		  	movie.change_mode()
		  else :
			  pass
			  # Add key_pressed to mod_features
	movie.clear_key_pressed()
	
	# ==== Gestion des trackbar (mise à jour)
	tracking_data['erosion'] = gestion_track.var['erosion']
	tracking_data['seuil1'] = gestion_track.var['seuil1']
	tracking_data['seuil2'] = gestion_track.var['seuil2']
	tracking_data['seuil3'] = gestion_track.var['seuil3']
	
	# ==== Affichage de l'image et gestion des points
	font = cv.InitFont(cv.CV_FONT_HERSHEY_PLAIN, 0.7, 0.7) 	# Initialisation de la police
	
	view = movie.get_view()
	im = self.buffer_images[view[0]]
	out = cv.CreateImage(cv.GetSize(im), im.depth, 3)
	cv.Copy(self.buffer_images[view[0]], out)
	
	name = view[1]
	cv.PutText(out, name, (size[0]-140, 20), font, 255)
	"""if view == 1:					# Affichage de l'image brute
			cv.Copy(frame, out)
	   		if tracking_data['night_mode']:
				# night mode: only display the points
		   		 cv.SetZero(out)
			if draw_points :
				#for the_point in tracking_data['features']:
				#	cv.Circle(frame, (int(the_point[0]), int(the_point[1])), 3, (0, 255, 0, 0), -1, 8, 0)
				for the_point in tracking_data2['features']:
					cv.Circle(out, (int(the_point[0]), int(the_point[1])), 3, (255, 0, 0, 0), -1, 8, 0)
			cv.PutText(out, "Brut", (size[0]-50, 20), font, 255)
	elif view == 0 :					# Affichage de l'image après traitement
		cv.Copy(grey2, out)
		if tracking_data['night_mode']:
				# night mode: only display the points
			 cv.SetZero(out)
		if draw_points :
			pass
			#for the_point in tracking_data['features']:
			#	cv.Circle(grey2, (int(the_point[0]), int(the_point[1])), 3, (0, 255, 0, 0), -1, 8, 0) 
		cv.PutText(out, "Grey", (size[0]-50, 20), font, 255)
	elif view == 2 :						# Affichage de l'image après différence
		cv.Copy(diff, out)
		if tracking_data['night_mode']:
			# night mode: only display the points
			 cv.SetZero(out)
		if draw_points :
			pass
			#for the_point in tracking_data['features']:
			#	cv.Circle(diff, (int(the_point[0]), int(the_point[1])), 3, (0, 255, 0, 0), -1, 8, 0)
		cv.PutText(out, "diff", (size[0]-50, 20), font, 255)"""
	cv.PutText(out, "fps: " + str(fps[2]*movie.get_speed())[:-6], (10, 20), font, 255)
	cv.PutText(out, "speed: " + str(movie.get_speed()), (10, 35), font, 255)
	cv.PutText(out, "mode: " + movie.get_mode(), (10, 50), font, 255)
	cv.PutText(out, "Frame : " + str(movie.get_frame_index()) , (10, 60), font, 255)

	if arch == 'debian' :
		cv.ShowImage(self.window_name, out)
	elif arch == 'mac' :
		a = numpy.asarray(cv.GetMat(out))		# Getting and saving image
		cv2.imwrite(tmp_image+'1'+tmp_image_ext,a.astype('uint8'))
		#misc.imsave(tmp_image+'1'+tmp_image_ext,a[:,:,[0,1,2]].astype('uint8'))# Saving
		
		locked = os.path.isfile(tmp_lock)
		if not locked :			# Check lock file
			open(tmp_lock, 'w').close()				# Locking file
			os.rename(tmp_image+'1'+tmp_image_ext, tmp_image+tmp_image_ext)
			try :
				os.remove(tmp_lock)
			except :
				pass
		if os.path.isfile(tmp_letter) :
			f=open(tmp_letter, 'r')
			l=f.read()
			f.close()
			try :
				os.remove(tmp_letter)
			except :
				pass
			print l[0]
			movie.set_key_pressed(l[0])
		if os.path.isfile(tmp_click) :
			f=open(tmp_click, 'r')
			c=f.read()
			f.close()
			try :
				os.remove(tmp_click)
			except :
				pass
			type_click = c[0]
			x = int(c.split(' ')[1])
			y = int(c.split(' ')[2])
			if type_click == 'c' :
				movie.set_click((x,y))
				movie.features.set_click((x,y))	
				tracking_data['pt'] = (x, y)
				tracking_data['add_remove_pt'] = True		
			elif type_click == 'm' :
				movie.set_drag_drop((x,y))
				movie.grid.mouse_update((x,y))
			else :
				pass

		
def on_mouse (event, x, y, flags, dico):	# the callback
	# we will use the global pt and add_remove_pt	
	#if data['image'] is None:
	#	# not initialized, so skip
	#	#return
	#if data['image'].origin != 0:
	#	# different origin
	#	#y = data['image'].height - y
	#y = 480 -y
	data = dico['data']
	movie = dico['movie']
	if event == cv.CV_EVENT_LBUTTONDOWN:
		# user has click, so memorize it
		movie.set_click((x,y))
		movie.features.set_click((x,y))
		print (x,y)
		data['pt'] = (x, y)
		data['add_remove_pt'] = True
	if flags == cv.CV_EVENT_FLAG_LBUTTON :
		movie.grid.mouse_update((x,y))
	else :
		pass
		# Unset the drag_drop flag

class GestionTrackbar() :
	def seuil1(self, pos) :
		if pos%2 == 0 :
			pos = pos+1
		if pos < 3 :
			pos = 3
		self.var['seuil1'] = pos
	def seuil2(self, pos) :
		self.var['seuil2'] = pos
	def seuil3(self, pos) :
		self.var['seuil3'] = pos
	def erosion(self, pos) :
		self.var['erosion'] = pos   
		
		
