# File handling all that is related to opening images that are located by
#+ a CellTracking file

class LoadFile :
	def __init__(self, parent, mod_loaders, movie) :
		self.movie = movie
		self.file = ''
		self.parent = parent
		self.accepted_format = ['ct', 'txt', 'h5']
		self.loaders_dict = mod_loaders
	def show_tab_GTK(self) :
		"""Returns a tab structure for the file opener"""
	
	def show_open_table_GTK(self, gtk) :
		"""returns a table that can be added to the open panel.
		This is a temporary function since the open panel will be replaced
		by tabs"""
		table = gtk.Table(1,1)
		
		fc = gtk.FileChooserButton('Select CellTracking file')
		fc.connect("selection-changed", self._folder_selected)
		fc.show()
		table.attach(fc, 0,2,0,1)
		
		table.show()
		return table

	def _folder_selected(self, w) :
		filename = w.get_filename()
		if filename != self.file :
			self.file = filename
			self.file_name = filename.split('/')[-1].split('.')[0]
			success = self.movie.import_export.load_file(filename)
			if success :
				dic = self.movie.import_export.get_dict('channels')
				self.parent.clear_channels()
				self.create_channels(dic)
			else :
				print 'Opening failed'
			#self.sb_old_value = 0
			#self.b_increment.set_value(1)
			
	def create_channels(self, dic) :
		"""Function that adds new channels"""
		if self.file != '' :
			self.parent.set_name(self.file_name)
			#self.parent.channels.associate_list = dic['associate_list']['value']
			#self.parent.channels.associate_list_i = dic['associate_list_i']['value']
			ch_dic = dic['channels']['value']
			for l in ch_dic :
				#print str(l['asso_list']['value'])+'toto'
				loader_data = {}
				for key in l['loader_data']['value'] :
					loader_data[key] = l['loader_data']['value'][key]['value']
				loader = self.loaders_dict[l['loader_type']['value']].Loader(loader_data)
				#print 'NAME '+  l['name']['value']
				self.parent.add_channel({"name" : l['name']['value'],
							'text_label' : 'toto la trompette',
							'name_index' : l['name_index']['value'],
							'loader' : loader,
							'asso_list' : l['asso_list']['value']}
							, False)				
