# Returns a local variance computed vith imageJ
# This is also an example of an ImageJ/Java - CellTracking/Python binding
import re, os, cv

import gtk
class Loader :
	def __init__(self, data) :
		"""A first init, but all the parameters ore not properly initiated"""
		self.loader_type = 'variance'
		self.output_folder = './tmp/variance/'
		self.name_source = data['name_source']
		self.source_channel = data['source_channel']	# The channel to be modified
		self.movie = data['movie']						# The source movie
		self.nb_files = self.movie.get_nb_frames()		# COMMENTED ONLY FOR DEBUG
		 
	def update(self) :
		pass
	def get_loader_type(self) :
		"""The first value is 'is_inherited'"""
		return (True, self.loader_type)
	def init(self) :
		"""The final initialization"""
		# Creating/init the output directory
		path = self.output_folder + self.movie.get_name() + '-' + self.name_source + '/'
		create = False
		print "-- Checking folders"
		if not os.path.isdir(path) :
			os.mkdir(path)
			create = True
		elif len(os.listdir(path)) != self.nb_files :
			create = True
		print "-- Exporting variance"
		if create :
			# Loading and starting JVM and ImageJ
			import jpype
			jpype.startJVM('/usr/lib/jvm/java-6-openjdk/jre/lib/i386/client/libjvm.so', '-Djava.class.path=/home/maxime/Programmes/Fiji.app/jars/ij.jar') 	# you can then access to the basic java functions
			ij = jpype.JPackage('ij')		# Loading ImageJ interface
			for i in range(self.nb_files) :
				if i%5 == 0 :
					print 'variance' + str(i) + '.png'
				p = path + 'variance' + str(i) + '.png'
				im_p = self.source_channel.loader.get_frame_path(i)
				im = ij.IJ.openImage(im_p)
				ij.IJ.run(im, "8-bit", "");
				ij.IJ.run(im, "Variance...", "radius=7")
				ij.IJ.save(im, p)
				
				
			jpype.shutdownJVM()
		else :
			print 'Opening already saved images at path ' + path
		self.folder = path
		print "-- Done!"
		# Looping
		# Get image
		# print something
		# Run imageJ
	def get_nb_frames(self) :
		return self.nb_files
	def get_frame_path(self, i) :
		return self.folder + 'variance' + str(i) + '.png'
	def get_frame_32bits(self, i) :
		"""Upscale to 32 bits to create fake 32 bits channel required by some modules"""
		p = self.get_frame_path(i)
		im = cv.LoadImage(p)
		out = cv.CreateImage(cv.GetSize(im),32, im.channels)
		cv.Convert(im, out)
		return out
		
	def get_frame_CV(self, i) :
		p = self.get_frame_path(i)
		#p = self.folder + 'variance' + str(i) + '.png'
		return cv.LoadImage(p)	# Return image

if __name__=='__main__' :
	dico = {'name_source' : 'toto',
			'source_channel' : '',
			'movie' : ''}
	mod = Loader(dico)
	mod.folder = '../tmp/variance/H3bis-bf_out/'
	#print mod.get_frame_32bits(0).depth
